﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Interactivity;
using System.Windows.Controls.Primitives;
using System.Windows.Automation.Peers;
using System.Windows.Automation.Provider;

namespace SLTrigger
{
    public class InvokeTargetAction : TargetedTriggerAction<UIElement>
    {
        private UIElement element;

        /// <summary>
        /// 装载对象
        /// </summary>
        protected override void OnAttached()
        {
            base.OnAttached();
            if (Target != null)
            {
                element = Target;
            }
        }
        /// <summary>
        /// 卸载对象
        /// </summary>
        protected override void OnDetaching()
        {
            base.OnDetaching();
            element = null;
        }

        /// <summary>
        /// 当此Action的TargetName属性赋值为某个按钮名称时出发此事件
        /// </summary>
        /// <param name="oldTarget"></param>
        /// <param name="newTarget"></param>
        protected override void OnTargetChanged(UIElement oldTarget, UIElement newTarget)
        {
            base.OnTargetChanged(oldTarget, newTarget);
            if (element == null)
            {
                element = newTarget;
            }
        }

        /// <summary>
        /// 当触发器触发时运行此函数
        /// </summary>
        /// <param name="parameter"></param>
        protected override void Invoke(object parameter)
        {
            ButtonBase btn = element as ButtonBase;
            AutomationPeer peer = FrameworkElementAutomationPeer.CreatePeerForElement(btn); ;
            IInvokeProvider invokeProvider = peer.GetPattern(PatternInterface.Invoke) as IInvokeProvider;
            invokeProvider.Invoke();
        }

    }
}
