﻿using System;
using System.Windows;
using System.Windows.Input;
using System.Windows.Interactivity;
using System.Windows.Threading;

namespace SLTrigger
{
    public class PaggerTrigger : TriggerBase<UIElement>
    {
        private Point _downPosition;

        protected override void OnAttached()
        {
            base.OnAttached();
            //加载事件
            AssociatedObject.MouseLeftButtonDown += new MouseButtonEventHandler(AssociatedObject_MouseLeftButtonDown);
            AssociatedObject.MouseLeftButtonUp += new MouseButtonEventHandler(AssociatedObject_MouseLeftButtonUp);
        }

        void AssociatedObject_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            UIElement element = sender as UIElement;
            _downPosition = e.GetPosition(element);
        }

        void AssociatedObject_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            UIElement element = sender as UIElement;
            Point position = e.GetPosition(element);
            double X_Content =  position.X - _downPosition.X ;
            PageEnum pageEnum = PageEnum.PageLeft;
            if (Math.Abs(X_Content) > 10)
            {
                if (X_Content > 0)
                {
                    pageEnum = PageEnum.PageRight;
                }
                else
                {
                    pageEnum = PageEnum.PageLeft;
                }
                InvokeActions(pageEnum);
            }
        }

        protected override void OnDetaching()
        {
            base.OnDetaching();
            //卸载事件
            AssociatedObject.MouseLeftButtonDown -= new MouseButtonEventHandler(AssociatedObject_MouseLeftButtonDown);
            AssociatedObject.MouseLeftButtonUp -= new MouseButtonEventHandler(AssociatedObject_MouseLeftButtonUp);
        }
    }

    /// <summary>
    /// 指示翻页方向枚举
    /// </summary>
    public enum PageEnum
    { 
        /// <summary>
        /// 左翻页
        /// </summary>
        PageLeft,

        /// <summary>
        /// 右翻页
        /// </summary>
        PageRight
    }
}
